import * as i0 from '@angular/core';
import { Injectable, Component, EventEmitter, Input, Output, NgModule } from '@angular/core';
import * as i2 from '@angular/cdk/drag-drop';
import { moveItemInArray, DragDropModule } from '@angular/cdk/drag-drop';
import * as i1 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i1$1 from '@angular/cdk/clipboard';
import { ClipboardModule } from '@angular/cdk/clipboard';

class UiControlsService {
    constructor() { }
}
UiControlsService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: UiControlsService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
UiControlsService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: UiControlsService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: UiControlsService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class UiControlsComponent {
    constructor() { }
    ngOnInit() {
    }
}
UiControlsComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: UiControlsComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
UiControlsComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.6", type: UiControlsComponent, selector: "lib-ui-controls", ngImport: i0, template: `
    <p>
      ui-controls works!
    </p>
  `, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: UiControlsComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-ui-controls', template: `
    <p>
      ui-controls works!
    </p>
  ` }]
        }], ctorParameters: function () { return []; } });

class CardListComponent {
    constructor() {
        this.cards = [];
        this.cardChange = new EventEmitter();
    }
    ngOnInit() {
    }
    sortCards(event) {
        moveItemInArray(this.cards, event.previousIndex, event.currentIndex);
        this.cardChange.emit();
    }
}
CardListComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: CardListComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CardListComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.6", type: CardListComponent, selector: "lib-card-list", inputs: { cards: "cards" }, outputs: { cardChange: "cardChange" }, ngImport: i0, template: "<div  cdkDropListOrientation=\"horizontal\" cdkDropList \n(cdkDropListDropped)=\"sortCards($event)\">\n  <div cdkDrag class=\"card m-4\" *ngFor=\"let card of cards\">\n    <header class=\"card-header\">\n      <p class=\"card-header-title\">{{ card.title }}</p>\n    </header>\n    <div class=\"card-content\">\n      <div class=\"content\">{{ card.description }}</div>\n    </div>\n    <footer class=\"card-footer\">\n      <a [href]=\"card.link\" class=\"card-footer-item\">View on Wikipedia</a>\n    </footer>\n  </div>\n</div>\n", styles: [":host>div{display:grid;grid-auto-flow:column;overflow:auto}.card{width:200px}\n"], dependencies: [{ kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.CdkDropList, selector: "[cdkDropList], cdk-drop-list", inputs: ["cdkDropListConnectedTo", "cdkDropListData", "cdkDropListOrientation", "id", "cdkDropListLockAxis", "cdkDropListDisabled", "cdkDropListSortingDisabled", "cdkDropListEnterPredicate", "cdkDropListSortPredicate", "cdkDropListAutoScrollDisabled", "cdkDropListAutoScrollStep"], outputs: ["cdkDropListDropped", "cdkDropListEntered", "cdkDropListExited", "cdkDropListSorted"], exportAs: ["cdkDropList"] }, { kind: "directive", type: i2.CdkDrag, selector: "[cdkDrag]", inputs: ["cdkDragData", "cdkDragLockAxis", "cdkDragRootElement", "cdkDragBoundary", "cdkDragStartDelay", "cdkDragFreeDragPosition", "cdkDragDisabled", "cdkDragConstrainPosition", "cdkDragPreviewClass", "cdkDragPreviewContainer"], outputs: ["cdkDragStarted", "cdkDragReleased", "cdkDragEnded", "cdkDragEntered", "cdkDragExited", "cdkDragDropped", "cdkDragMoved"], exportAs: ["cdkDrag"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: CardListComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-card-list', template: "<div  cdkDropListOrientation=\"horizontal\" cdkDropList \n(cdkDropListDropped)=\"sortCards($event)\">\n  <div cdkDrag class=\"card m-4\" *ngFor=\"let card of cards\">\n    <header class=\"card-header\">\n      <p class=\"card-header-title\">{{ card.title }}</p>\n    </header>\n    <div class=\"card-content\">\n      <div class=\"content\">{{ card.description }}</div>\n    </div>\n    <footer class=\"card-footer\">\n      <a [href]=\"card.link\" class=\"card-footer-item\">View on Wikipedia</a>\n    </footer>\n  </div>\n</div>\n", styles: [":host>div{display:grid;grid-auto-flow:column;overflow:auto}.card{width:200px}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { cards: [{
                type: Input
            }], cardChange: [{
                type: Output
            }] } });

class CopyButtonComponent {
    constructor() {
        this.data = '';
        this.copied = new EventEmitter();
    }
    ngOnInit() {
    }
    onCopy() {
        this.copied.next(this.data);
    }
}
CopyButtonComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: CopyButtonComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CopyButtonComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.6", type: CopyButtonComponent, selector: "lib-copy-button", inputs: { data: "data" }, outputs: { copied: "copied" }, ngImport: i0, template: "<button\n  class=\"button is-light is-primary\"\n  [cdkCopyToClipboard]=\"data\"\n  (cdkCopyToClipboardCopied)=\"onCopy()\"\n>\n  Copy\n</button>\n", styles: [""], dependencies: [{ kind: "directive", type: i1$1.CdkCopyToClipboard, selector: "[cdkCopyToClipboard]", inputs: ["cdkCopyToClipboard", "cdkCopyToClipboardAttempts"], outputs: ["cdkCopyToClipboardCopied"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: CopyButtonComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-copy-button', template: "<button\n  class=\"button is-light is-primary\"\n  [cdkCopyToClipboard]=\"data\"\n  (cdkCopyToClipboardCopied)=\"onCopy()\"\n>\n  Copy\n</button>\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { data: [{
                type: Input
            }], copied: [{
                type: Output
            }] } });

class UiControlsModule {
}
UiControlsModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: UiControlsModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
UiControlsModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.6", ngImport: i0, type: UiControlsModule, declarations: [UiControlsComponent,
        CardListComponent,
        CopyButtonComponent], imports: [CommonModule,
        DragDropModule,
        ClipboardModule], exports: [UiControlsComponent,
        CardListComponent,
        CopyButtonComponent] });
UiControlsModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: UiControlsModule, imports: [CommonModule,
        DragDropModule,
        ClipboardModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.6", ngImport: i0, type: UiControlsModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        UiControlsComponent,
                        CardListComponent,
                        CopyButtonComponent
                    ],
                    imports: [
                        CommonModule,
                        DragDropModule,
                        ClipboardModule
                    ],
                    exports: [
                        UiControlsComponent,
                        CardListComponent,
                        CopyButtonComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of ui-controls
 */

/**
 * Generated bundle index. Do not edit.
 */

export { CardListComponent, CopyButtonComponent, UiControlsComponent, UiControlsModule, UiControlsService };
//# sourceMappingURL=new-ui-controls-ko.mjs.map
